#!/usr/bin/perl -w 

package esmith::FormMagick::Panel::logonscript;

use strict;

use esmith::FormMagick;
use esmith::ConfigDB;
use esmith::cgi;
use File::Basename;
use Exporter;
use Carp;

our @ISA = qw(esmith::FormMagick Exporter);

our @EXPORT = qw(
    read_logon
    save_change
    get_prop
);

our $c = esmith::ConfigDB->open() || die "Couldn't open config db";

sub new {
    shift;
    my $self = esmith::FormMagick->new();
    $self->{calling_package} = (caller)[0];
    bless $self;
    return $self;
}

sub get_prop {
    my $self = shift;
    my $item = shift;
    my $prop = shift;
    return ($c->get($item)->prop($prop));
}

sub read_logonscript {
    my $self = shift;
    my $ret = '';
    if (! open (LOGON, "</home/e-smith/files/samba/netlogon/netlogon.template")){
        $self->error('ERROR_OPEN_FILE','First');
        return;
    }
    while (<LOGON>){
        $ret .= $_;
    }
    close LOGON;
    return $ret;
}

sub save_change {
    my $self = shift;
    my $q = $self->{cgi};
    my $logon = $q->param('logonscript');
    my $drive = $q->param('homedrive');
    if (! open (LOGON, ">/home/e-smith/files/samba/netlogon/netlogon.template")){
        $self->error('ERROR_OPEN_FILE','First');
        return;
    }
    print LOGON $logon;
    close LOGON;
    $c->set_prop('smb', 'LogonDrive', $drive);
    unless ( system ("/sbin/e-smith/signal-event", "workgroup-update") == 0 ){
        return $self->error('ERROR_OCCURED');;
    }
    return $self->success('SUCCESS');
}
